/* Own configuration library to assume compatibility
   with OE5BPA's TTGO T-Beam APRS Tracker. */

#ifndef M5ModemConfig_H
   #define M5ModemConfig_H

   #include <Arduino.h>
   #include <SPI.h>

   #define LORA_DEFAULT_SS_PIN    5
   #define LORA_DEFAULT_RESET_PIN 26
   #define LORA_DEFAULT_DIO0_PIN  36

   class Modem {
      public:
         Modem();
         uint8_t readRegister(uint8_t address);
         void writeRegister(uint8_t address, uint8_t value);

         void setPins(int ss = LORA_DEFAULT_SS_PIN, int reset = LORA_DEFAULT_RESET_PIN, int dio0 = LORA_DEFAULT_DIO0_PIN);
         void setSPIFrequency(uint32_t frequency);         


      private:
         SPISettings _spiSettings;
         int _ss;
         int _reset;
         int _dio0;
         int _frequency;
         int _packetIndex;
         int _implicitHeaderMode;
         void (*_onReceive)(int);
         uint8_t singleTransfer(uint8_t address, uint8_t value);
   };


#endif